<!doctype html>
<html lang="en">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no" />

    <title>Modern CI/CD Pipelines</title>

    <link rel="stylesheet" href="dist/reset.css" />
    <link rel="stylesheet" href="dist/reveal.css" />
    <link rel="stylesheet" href="dist/theme/outrun.css" />

    <!-- Theme used for syntax highlighted code -->
    <link rel="stylesheet" href="plugin/highlight/outrun-dark.css" />
  </head>

  <body>
    <div class="reveal">
      <div class="slides">
        <section>
          <h1>Modern<br />Continuous<br />Delivery<br />Pipelines</h1>
          <em>Chris Neuroth &amp; Raimo Radczewski</em>
        </section>
        <section>
          <h3>Hi</h3>
          <div style="float: left; margin: 10px">
            <img src="dist/christoph-avatar.jpg" class="avatar" /><br />
            <small><em>Chris any</em></small>
          </div>
          <div style="float: right; margin: 10px">
            <img src="dist/raimo-avatar.jpg" class="avatar" /><br />
            <small><em>Raimo he/him</em></small>
          </div>
          <p>We call ourselves <br /><b>Technical Agile Coaches</b>.</p>
          <p class="smaller">We help teams...</p>
          <ul class="smaller">
            <li>... collaborate better and more</li>
            <li>... build better software</li>
            <li>... tame their legacy systems</li>
            <li>... get out of the build trap</li>
          </ul>
        </section>
        <section>
          <h3>What we like to do</h3>
          <ul>
            <li>Do weekly coding katas with teams</li>
            <li>Facilitate ensemble sessions on refactorings</li>
            <li
              >Run day-long workshops on topics like <b>docker</b>, <b>hexagonal architecture</b> or
              <b>parallel change</b>
            </li>
            <li>Help teams design and optimize their delivery pipelines</li>
          </ul>
        </section>
        <section>
          <h3>What we really do</h3>
          <ul>
            <li>Yak-shave our way through undertested, abandoned legacy monoliths (we actually 💖 this) </li>
            <li>Advocate for more slack time in sprints</li>
            <li>Write YAML for GitHub Actions, and then write YAML for Helm Charts </li>
          </ul>
        </section>
        <section>
          <h3>CI/CD Workshop</h3>
          <p class="smaller">For the last year, we ran weekly workshop with 3 teams on... </p>
          <ul>
            <li
              >Kubernetes for developers<br /><small><em>Resources, Deployment Strategies, GitOps</em></small>
            </li>
            <li
              >Continuous Delivery<br /><small><em>Testing for confidence, deployments as a non-event</em></small>
            </li>
            <li
              >Hexagonal Architecture &amp; 12-factor apps<br /><small
                ><em>Building resilient, maintainable microservices</em></small
              >
            </li>
          </ul>
        </section>
        <section>
          <h2>Today</h2>
          <ul>
            <li><strong>Extreme Programming </strong><br /><s>3.0</s> as if you mean it </li>
            <li><strong>First principles in CI/CD</strong><br />to obsess over</li>
            <li><strong>Archeology</strong><br />Hey coach, what's the problem, how do we fix it?</li>
            <li class="small"
              ><strong>DLC Content:</strong><br />Coding, How to optimize docker builds, rants on kubernetes
            </li>
          </ul>
        </section>
        <section>
          <section>
            <h2>The perfect<br />delivery pipeline</h2>
            <ul class="small">
              <li>Every commit on <code>main</code> is deployed to production </li>
              <li>The whole pipeline runs in less than <em data-extreme="10 minutes" data-meh="1 hour">1 hour</em></li>
              <li>The team deploys <em>multiple times a day</em></li>
              <li>All steps are done <em>automatically</em></li>
              <li><em>No one</em> actively monitors the deployment</li>
              <li><em>No user</em> notices the deployment</li>
            </ul>
            <div class="pipeline pipeline-inline pipeline-with-arrows" style="margin: 32px 0">
              <div class="pipeline-item-group">
                <div class="pipeline-item pipeline-item-small">
                  <span>Unit-Test</span>
                </div>
                <div class="pipeline-item pipeline-item-small">
                  <span>Integration-Test</span>
                </div>
                <div class="pipeline-item pipeline-item-small">
                  <span>Build</span>
                </div>
              </div>
              <div class="pipeline-item-group-bracket">&nbsp;</div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item pipeline-item-small">
                <span>Deployment</span>
              </div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item-group">
                <div class="pipeline-item pipeline-item-small">
                  <span>Progressive Rollout</span>
                </div>
                <div class="pipeline-item pipeline-item-small">
                  <span>Smoke Test</span>
                </div>
              </div>
              <div class="pipeline-item-group-bracket">&nbsp;</div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item-group">
                <div class="pipeline-item pipeline-item-small">
                  <span>System Tests</span>
                </div>
                <div class="pipeline-item pipeline-item-small">
                  <span>Monitoring</span>
                </div>
              </div>
            </div>
          </section>
          <section>
            <h3 class="h1">Extreme<br />Programming</h3>

            <p><code>Code</code> is always...</p>

            <ul>
              <li>written in response to a <strong>test</strong> </li>
              <li>constantly <strong>refactored</strong> so it doesn't rot </li>
              <li>co-created in a <strong>pair</strong> or an <strong>ensemble</strong> </li>
              <li><strong>running in production</strong> as early as possible </li>
            </ul>
          </section>

          <section>
            <h3 class="h1">Continuous<br />Integration</h3>

            <p>Minimizing the time from<br /><b>code written</b> to <b>code...</b></p>

            <ul>
              <li>on <strong>mainline</strong>,</li>
              <li><strong>reviewed</strong> and <strong>tested</strong>,</li>
              <li><strong>integrated</strong> with other changes</li>
            </ul>
          </section>

          <section>
            <h3 class="h1">Continuous<br />Delivery</h3>

            <p>Minimizing the time from <br /><b>code written</b> to <b>code...</b></p>

            <ul>
              <li>deployed to <strong>real users</strong>,</li>
              <li>running in a <strong>real environment</strong>,</li>
              <li>ready to be <strong>evaluated</strong></li>
            </ul>
          </section>

          <section>
            <h1>WHY</h1>
            <p
              ><strong>There is no other way <br />to develop software sustainably</strong></p
            >

            <aside class="notes">
              <ul>
                <li
                  >Brent: Average tenure in our industry is 2.5 yrs. The guy who's been working for your company for 10
                  years will leave</li
                >
                <li
                  >Finished: Software is never finished: How many of you have a project with e.g. Scala, Groovy, Gulp,
                  Browserify etc.</li
                >
                <li
                  >Turnover: No one likes software that breaks in production and is too brittle to touch. You write code
                  for yourself, and for the third team to take over your project after you're gone</li
                >
              </ul>
            </aside>
          </section>
        </section>
        <section>
          <section data-auto-animate>
            <h1>Feedback Loops</h1>
            <p>The thing that tells you that you're wrong</p>
          </section>
          <section data-auto-animate>
            <h1>Feedback Loops</h1>
            <p>The thing that tells you that you're wrong</p>
            <ol
              class="smaller"
              style="display: grid; grid-template-rows: 1fr 1fr 1fr 1fr 1fr 1fr; grid-auto-flow: column; gap: 0 50px">
              <li class="fragment">Compiler / IDE</li>
              <li class="fragment">Unit-Tests</li>
              <li class="fragment">Integration-Tests</li>
              <li class="fragment">Postman / Browser</li>
              <li class="fragment">Branch build</li>
              <li class="fragment">Pull Request Review</li>
              <li class="fragment">mainline build</li>
              <li class="fragment">staging deployment</li>
              <li class="fragment">staging system tests</li>
              <li class="fragment">manual staging QA tests</li>
              <li class="fragment">product managers giving you feedback</li>
              <li class="fragment">production deployment</li>
              <li class="fragment">production system tests</li>
              <li class="fragment">manual production QA tests</li>
              <li class="fragment">staring at a dashboard and logs</li>
              <li class="fragment">product managers giving you feedback</li>
              <li class="fragment">users giving you feedback</li>
              <li class="fragment">emails waking you up</li>
            </ol>
          </section>
          <section>
            <h2>Dev<br />Feeback Loop</h2>
            <p><small>The time it takes for code to get feedback from another person</small></p>
            <ol class="smaller">
              <li>Compiler / IDE</li>
              <li>Unit-Tests</li>
              <li>Integration-Tests</li>
              <li>Postman / Browser</li>
              <li>Branch build</li>
              <li>Pull Request Review</li>
            </ol>
            <p>Cycle Time: <b>~3 days</b></p>
          </section>
          <section>
            <h2>Integration<br />Feeback Loop</h2>
            <p><small>The time it takes for code to be integrated</small></p>
            <ol class="smaller" style="counter-reset: li 6">
              <li>mainline build</li>
              <li>staging deployment</li>
              <li>staging system tests</li>
              <li>manual staging QA tests</li>
              <li>product managers giving you feedback</li>
            </ol>
            <p>Cycle Time: <b>~3 days</b><br />Lead Time: <b>~6 days</b></p>
          </section>
          <section>
            <h2>Business<br />Feedback Loop</h2>
            <p><small>The time it takes for code to make money</small></p>
            <ol class="smaller" style="counter-reset: li 11">
              <li>production deployment</li>
              <li>production system tests</li>
              <li>manual production QA tests</li>
              <li>staring at a dashboard and logs</li>
              <li>product managers giving you feedback</li>
              <li>users giving you feedback</li>
              <li>emails waking you up</li>
            </ol>
            <p>Cycle Time: <b>~4 weeks</b><br />Lead Time: <b>~5 weeks</b></p>
          </section>
          <section>
            <h2>Your Feedback Loops</h2>
            <p><small>The feedback loops you own</small></p>
            <ol
              class="smaller"
              style="display: grid; grid-template-rows: 1fr 1fr 1fr 1fr 1fr 1fr; grid-auto-flow: column; gap: 0 50px">
              <li class="fragment highlight-green" data-fragment-index="2">Compiler / IDE</li>
              <li class="fragment highlight-green" data-fragment-index="2">Unit-Tests</li>
              <li class="fragment highlight-green" data-fragment-index="2">Integration-Tests</li>
              <li class="fragment strike highlight-red" data-fragment-index="3">Postman / Browser</li>
              <li class="fragment highlight-green" data-fragment-index="2">Branch build</li>
              <li class="fragment strike highlight-red" data-fragment-index="3">Pull Request Review</li>
              <li class="fragment highlight-green" data-fragment-index="2">mainline build</li>
              <li class="fragment highlight-green" data-fragment-index="2">staging deployment</li>
              <li class="fragment highlight-green" data-fragment-index="2">staging system tests</li>
              <li class="fragment strike highlight-red" data-fragment-index="3">manual staging QA tests</li>
              <li class="fragment semi-fade-out" data-fragment-index="1">product managers giving you feedback</li>
              <li class="fragment highlight-green" data-fragment-index="2">production deployment</li>
              <li class="fragment highlight-green" data-fragment-index="2">production system tests</li>
              <li class="fragment strike highlight-red" data-fragment-index="3">manual production QA tests</li>
              <li class="fragment strike highlight-red" data-fragment-index="3">staring at a dashboard and logs</li>
              <li class="fragment semi-fade-out" data-fragment-index="1">product managers giving you feedback</li>
              <li class="fragment semi-fade-out" data-fragment-index="1">users giving you feedback</li>
              <li class="fragment highlight-green" data-fragment-index="2">emails waking you up</li>
            </ol>
          </section>
        </section>
        <section>
          <section>
            <h1>Demo</h1>
            <ul>
              <blockquote class="smaller" style="width: auto"
                >As a SoCraTes attendee, <br />in order to have a consistent user experience and no surprises,<br/>if the app doesn't know where a room on the schedule is on the map,<br/>then it shouldn't suggest I can click on that room</blockquote
              >
            </ul>
          </section>
          <section>
            <h1>Recap</h1>
            <ul class="small">
              <li>The whole pipeline to production ran in lass than <b>5 minutes</b></li>
              <li><code>git push</code> was the only manual action</li>
              <li>21 Unit Tests took 20s, 11 Integration Tests took 2m</li>
              <li>There was a smoke test <b>before public traffic hit the canary pod</b></li>
              <li>There was <b>no user impact</b> of the rollout</li>
              <li>We can apply fine-grained changes to the rollout</li>
              <li
                >A whole feature was hidden behind a <b>feature flag</b> that can be switched on without a
                redeployment</li
              >
            </ul>
          </section>
          <section>
            <h3>Capabilities</h3>
            <table class="smaller">
              <tr>
                <th>&nbsp;</th>
                <th>Capability</th>
              </tr>
              <tr>
                <th>Infrastructure as Code</th>
                <td>Reliably and automatically bootstrap, update and restore your infrastructure </td>
              </tr>
              <tr>
                <th>GitOps</th>
                <td>Reliably and automatically roll out and reproduce your system state </td>
              </tr>
              <tr>
                <th>ServiceMesh</th>
                <td>Control and inspect your network traffic</td>
              </tr>
              <tr>
                <th>Monitoring</th>
                <td>Meaningfully assess the health of your production system </td>
              </tr>
              <tr>
                <th>Progressive Rollout</th>
                <td>Zero-downtime deployments with automatic verification</td>
              </tr>
              <tr>
                <th>Feature Flags</th>
                <td>De-couple deployments from releases</td>
              </tr>
              <tr>
                <th>12-factor app</th>
                <td>Stateless, universal and arbitrarily scalable application instances </td>
              </tr>
            </table>
          </section>
        </section>

        <section>
          <section>
            <h1>First Principles</h1>
          </section>
          <section data-auto-animate>
            <h1>Obsess over...</h1>
            <ol>
              <li
                >Feedback<br /><small
                  >If your tests are <span style="color: green">green</span>, your app will be fully functional.</small
                >
              </li>
              <li>Cycle Time<br /><small>Build, test, deploy as fast as possible.</small> </li>
              <li>Waste<br /><small>Go all Marie Kondo on any manual step in your delivery process</small> </li>
              <li>Ownership<br /><small>If you build it, you own how it's run.</small> </li>
            </ol>
          </section>
        </section>
        <section>
          <section>
            <h1>1. Feedback</h1>
            <img src="/dist/homer_alarm.gif" class="neon-pink-box-shadow" />
          </section>
          <section>
            <span class="chapter">1. Feedback</span>
            <h3>Hard axiom #1</h3>
            <p
              >Your signal is never <span style="color: green">green</span>, <br />even though it should be
              <span style="color: red">red</span></p
            >
            <p class="small"
              >If your tests, pipelines or alerts are <span style="color: green">green</span>, <br />your app is
              <b>working and does not require your attention</b>.
            </p>
          </section>
          <section>
            <span class="chapter">1. Feedback</span>
            <h3>Hard axiom #2</h3>
            <p
              >Your signal is never <span style="color: red">red</span>, <br />even though it should be
              <span style="color: green">green</span></p
            >
            <p class="small"
              >If your tests, pipelines or alerts are <span style="color: red">red</span>, <br />your app is
              <b>not working and requires your attention</b>.
            </p>
          </section>
          <section>
            <span class="chapter">1. Feedback</span>
            <h3>Receiving feedback</h3>
            <p>
              <span style="color: red">❌ <s>Watching and waiting</s></span
              ><br /><span style="color: green">✅ Getting alerted</span>
            </p>
            <ul>
              <li>Alerts for any failure</li>
              <li>In your <b>main realtime comms. channel</b></li>
              <li><b>Always specific enough to be actionable</b></li>
            </ul>
          </section>
          <section>
            <span class="chapter">1. Feedback</span>
            <h3>Reacting to problems</h3>
            <ul>
              <li>All hands on deck</li>
              <li>Fix the issue, then fix the system</li>
              <li>0 known problems in production</li>
            </ul>
            <aside class="notes">
              <ul>
                <li
                  >Donald G. Reinertsen in The Principles of Product Development Flow: Each bug you accept adds
                  additional overhead to the next one you find (do you already know this bug?) and to your reporting
                  (this is not fixed yet, planned in Q3 etc)
                </li>
                <li
                  >Following up immediately is probably the hardest sell in an average organization, but it has to be
                  done
                </li>
              </ul>
            </aside>
          </section>
        </section>
        <section>
          <section data-auto-animate>
            <h1>2. Cycle Time</h1>
          </section>

          <section>
            <h1>Optimizing Feedback Cycles</h1>
            <h2>Being fast by default</h2>
            <p class="h3">Being slow as an exception</p>
          </section>

          <section data-auto-animate>
            <div class="pipeline-container">
              <div>
                <div class="slide-top slide-left">
                  <div class="pipeline">
                    <div class="pipeline-item" data-id="development"
                      >Dev<br /><small>&lt; <span data-extreme="1hr" data-meh="6hrs">6hrs</span></small>
                    </div>
                  </div>
                </div>
              </div>
              <div class="pipeline-content">
                <h2>Development</h2>
                <p>
                  <small><b>Is the increment I'm working on right now working by itself? </b></small>
                </p>
                <table class="small">
                  <tr>
                    <th>Feedback Loop</th>
                    <th>No# of Cycles</th>
                    <th>Cycle Time</th>
                  </tr>
                  <tr>
                    <th>TDD Cycle</th>
                    <td>100's of times</td>
                    <td>seconds</td>
                  </tr>
                  <tr>
                    <th>Integration-Tests</th>
                    <td>10's of times</td>
                    <td>10s of seconds</td>
                  </tr>
                  <tr>
                    <th>System-Tests</th>
                    <td>several times</td>
                    <td>minutes</td>
                  </tr>
                  <tr>
                    <th>Review</th>
                    <td style="text-align: center" colspan="2">
                      <s>not necessary</s>
                    </td>
                  </tr>
                  <tr>
                    <th class="h3">Goal</th>
                    <th style="text-align: center" colspan="2">
                      &lt; <span data-extreme="1hr" data-meh="6h">6hrs</span> for an increment
                    </th>
                  </tr>
                </table>
              </div>
            </div>
          </section>
          <section data-auto-animate>
            <div class="pipeline-container">
              <div>
                <div class="slide-top slide-left">
                  <div class="pipeline">
                    <div class="pipeline-item" data-id="development"
                      >Dev<br /><small>&lt; <span data-extreme="1hr" data-meh="6h">6hrs</span></small>
                    </div>
                    <div class="pipeline-item" data-id="ci">CI<br /><small>&lt; <span data-extreme="5min" data-meh="10min">10min</span></small> </div>
                  </div>
                </div>
              </div>
              <div class="pipeline-content">
                <h2>CI Pipeline</h2>
                <p>
                  <small><b>Is the increment I worked on working together with other changes? </b></small>
                </p>
                <table class="small">
                  <tr>
                    <th>Feedback Loop</th>
                    <th>No# of Cycles</th>
                    <th>Cycle Time</th>
                  </tr>
                  <tr>
                    <th>Run all tests</th>
                    <td>once per increment</td>
                    <td>minutes</td>
                  </tr>
                  <tr>
                    <th>Full build</th>
                    <td>once per increment</td>
                    <td>minutes</td>
                  </tr>
                  <tr>
                    <th class="h3">Goal</th>
                    <th style="text-align: center" colspan="2"> &lt; <span data-extreme="5min" data-meh="10min">10min</span> for an increment </th>
                  </tr>
                </table>
              </div>
            </div>
          </section>
          <section data-auto-animate>
            <div class="pipeline-container">
              <div>
                <div class="slide-top slide-left">
                  <div class="pipeline">
                    <div class="pipeline-item" data-id="development"
                      >Dev<br /><small>&lt; <span data-extreme="1hr" data-meh="6h">6hrs</span></small>
                    </div>
                    <div class="pipeline-item" data-id="ci">CI<br /><small>&lt; <span data-extreme="5min" data-meh="10min">10min</span></small> </div>
                    <div class="pipeline-item" data-id="staging">Staging<br /><small>&lt; <span data-extreme="5min" data-meh="20min">20min</span></small> </div>
                  </div>
                </div>
              </div>
              <div class="pipeline-content">
                <h2>Staging</h2>
                <p>
                  <small><b>Is my increment working in a production-like environment? </b></small>
                </p>
                <table class="smaller">
                  <tr>
                    <th>Feedback Loop</th>
                    <th>No# of Cycles</th>
                    <th>Cycle Time</th>
                  </tr>
                  <tr>
                    <th>Initiate Deployment</th>
                    <td>once per increment</td>
                    <td>10s of seconds</td>
                  </tr>
                  <tr>
                    <th>Smoke Tests</th>
                    <td>once per increment</td>
                    <td>10s of seconds to minutes</td>
                  </tr>
                  <tr>
                    <th>System Tests</th>
                    <td>once per increment</td>
                    <td>minutes</td>
                  </tr>
                  <tr>
                    <th class="h3">Goal</th>
                    <th style="text-align: center" colspan="2"> &lt; <span data-extreme="5min" data-meh="20min">20min</span> for an increment </th>
                  </tr>
                </table>
              </div>
            </div>
          </section>
          <section data-auto-animate>
            <div class="pipeline-container">
              <div>
                <div class="slide-top slide-left">
                  <div class="pipeline">
                    <div class="pipeline-item" data-id="development"
                      >Dev<br /><small>&lt; <span data-extreme="1hr" data-meh="6h">6hrs</span></small>
                    </div>
                    <div class="pipeline-item" data-id="ci">CI<br /><small>&lt; <span data-extreme="5min" data-meh="10min">10min</span></small> </div>
                    <div class="pipeline-item" data-id="staging">Staging<br /><small>&lt; <span data-extreme="5min" data-meh="20min">20min</span></small> </div>
                    <div class="pipeline-item" data-id="prod">Prod<br /><small>&lt; <span data-extreme="10min" data-meh="20min">20min</span></small> </div>
                  </div>
                </div>
              </div>
              <div class="pipeline-content">
                <h2>Production</h2>
                <p>
                  <small><b>Is my increment working in production?</b></small>
                </p>
                <table class="smaller">
                  <tr>
                    <th>Feedback Loop</th>
                    <th>No# of Cycles</th>
                    <th>Cycle Time</th>
                  </tr>
                  <tr>
                    <th>Initiate Deployment</th>
                    <td>once per increment</td>
                    <td>10s of seconds</td>
                  </tr>
                  <tr>
                    <th>Smoke Tests</th>
                    <td>once per increment</td>
                    <td>10s of seconds to minutes</td>
                  </tr>
                  <tr>
                    <th>System Tests</th>
                    <td>once per increment</td>
                    <td>minutes</td>
                  </tr>
                  <tr>
                    <th class="h3">Goal</th>
                    <th style="text-align: center" colspan="2"> &lt; <span data-extreme="10min" data-meh="20min">20min</span> for an increment </th>
                  </tr>
                </table>
              </div>
            </div>
          </section>

          <section data-auto-animate>
            <h2>A good CI/CD process</h2>
            <div class="pipeline pipeline-inline">
              <div class="pipeline-item" style="flex-grow: 10" data-id="development">
                <span>Dev</span><small>&lt;<span data-extreme="1hr" data-meh="6h">6hrs</span></small>
              </div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item" style="flex-grow: 1" data-id="ci">
                <span>CI</span><small>&lt;<span data-extreme="5min" data-meh="10min">20min</span></small>
              </div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item" style="flex-grow: 2" data-id="staging">
                <span>Staging</span><small>&lt;<span data-extreme="5min" data-meh="20min">20min</span></small>
              </div>
              <div class="pipeline-arrow"></div>
              <div class="pipeline-item" style="flex-grow: 2" data-id="prod">
                <span>Prod</span><small>&lt;<span data-extreme="10min" data-meh="20min">20min</span></small>
              </div>
            </div>
            <p>From dev machine to production in ~<span data-extreme="1.5 hours" data-meh="1 day">1 day</span></p>
          </section>
          <section data-auto-animate>
            <h2>How it goes wrong</h2>
            <div class="pipeline pipeline-inline">
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-blur" data-id="development">
                <span>Dev</span><small>&lt;6hrs</small>
              </div>
              <div style="flex-grow: 1" class="pipeline-item pipeline-item-blur" data-id="ci">
                <span>CI</span><small>&lt;10min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-blur" data-id="staging">
                <span>Staging</span><small>&lt;20min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-blur" data-id="prod">
                <span>Prod</span><small>&lt;20min</small>
              </div>
            </div>
            <p><code>~1 day</code></p>
          </section>
          <section data-auto-animate>
            <h2>Take away good slicing</h2>
            <div class="pipeline pipeline-inline">
              <div class="pipeline-item" style="flex-grow: 10" data-id="development">
                <span>Dev</span><small><strong>&gt;3 days</strong></small>
              </div>
              <div style="flex-grow: 1" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>&lt;10min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="staging">
                <span>Staging</span><small>&lt;20min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="prod">
                <span>Prod</span><small>&lt;20min</small>
              </div>
            </div>
            <p><code>&gt; 3 days</code></p>
          </section>
          <section data-auto-animate>
            <h2>Add Pull Requests</h2>
            <div class="pipeline pipeline-inline">
              <div class="pipeline-item" style="flex-grow: 10" data-id="development">
                <span>Dev</span><small><strong>&gt;3 days</strong></small>
              </div>
              <div class="pipeline-item" style="flex-grow: 20" data-id="review">
                <span>Review</span><small><strong>&gt;5 days</strong></small>
              </div>
              <div style="flex-grow: 1" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>&lt;10min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="staging">
                <span>Staging</span><small>&lt;20min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="prod">
                <span>Prod</span><small>&lt;20min</small>
              </div>
            </div>
            <p><code>&gt; 8 days</code></p>
          </section>
          <section data-auto-animate>
            <h2>Add an unreliable CI</h2>
            <div class="pipeline pipeline-inline">
              <div class="pipeline-item" style="flex-grow: 10" data-id="development">
                <span>Dev</span><small><strong>&gt;3 days</strong></small>
              </div>
              <div class="pipeline-item-group" style="flex-grow: 20" data-id="review">
                <div class="pipeline-item pipeline-item-small">
                  <span>Review</span><small><strong>&gt;5 days</strong></small>
                </div>
                <div class="pipeline-item-sequence">
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                  <div class="pipeline-item pipeline-item-small"> <span>CI</span><small>1h</small> </div>
                </div>
              </div>
              <div style="flex-grow: 5" class="pipeline-item" data-id="ci"> <span>CI</span><small>1h</small> </div>
              <div style="flex-grow: 5" class="pipeline-item" data-id="ci"> <span>CI</span><small>1h</small> </div>
              <div style="flex-grow: 5" class="pipeline-item" data-id="ci"> <span>CI</span><small>1h</small> </div>
              <div style="flex-grow: 5" class="pipeline-item" data-id="ci"> <span>CI</span><small>1h</small> </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="staging">
                <span>Staging</span><small>&lt;20min</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="prod">
                <span>Prod</span><small>&lt;20min</small>
              </div>
            </div>
            <p><code>&gt; 9 days</code></p>
          </section>
          <section data-auto-animate>
            <h2>Add manual QA Step</h2>
            <div class="pipeline pipeline-inline">
              <div class="pipeline-item" style="flex-grow: 10" data-id="development">
                <span>Dev</span><small><strong>&gt;3 days</strong></small>
              </div>
              <div class="pipeline-item-group" style="flex-grow: 20" data-id="review">
                <div class="pipeline-item pipeline-item-small">
                  <span>Review</span><small><strong>&gt;5 days</strong></small>
                </div>
                <div class="pipeline-item-sequence">
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                  <div class="pipeline-item pipeline-item-small pipeline-item-blur">
                    <span>CI</span><small>1h</small>
                  </div>
                </div>
              </div>
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>1h</small>
              </div>
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>1h</small>
              </div>
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>1h</small>
              </div>
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="ci">
                <span>CI</span><small>1h</small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="staging">
                <span>Staging</span><small>&lt;20min</small>
              </div>
              <div style="flex-grow: 10" class="pipeline-item pipeline-item-small" data-id="qa">
                <span>QA</span><small><strong>&gt;1 day</strong></small>
              </div>
              <div style="flex-grow: 2" class="pipeline-item pipeline-item-small pipeline-item-blur" data-id="prod">
                <span>Prod</span><small>&lt;20min</small>
              </div>
            </div>
            <p><code>&gt; 10 days</code></p>
            <aside class="notes">
              It's so soul-crushing to watch a slow CI ten times in a row because you just want to deploy. Death by a
              thousand cuts. Let's see what you could do to reduce that time?
            </aside>
          </section>
        </section>
        <section>
          <section>
            <h1>3. Waste</h1>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Linting</h2>
            <ul>
              <li>A CI is too late to give feedback on codestyle</li>
              <li>Trust your tests, not your linter</li>
              <li>Use it for your own feedback, <br /><strong>but not on the critical path to production</strong> </li>
            </ul>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Reports</h2>
            <ul>
              <li>Just remove test-coverage reports. <br />You'll save 10-20% of time instantly.</li>
              <li>Use it for your own feedback, <br /><strong>but not on the critical path to production</strong> </li>
            </ul>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Manual Testing</h2>
            <ul>
              <li>If there's a test plan, <br /><b>why not automate it?</b></li>
              <li>If there's no test plan, <br /><b>how do you know you're done?</b></li>
            </ul>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Intuition</h2>
            <p><q>I have a feeling for when the system is unhealthy</q></p>
            <p><q>5 errors at startup are okay, 10 are a problem</q></p>
            <p class="small fragment">🎉 Congrats, you just won the lottery and the company is done 🎉 </p>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Deploy Windows &amp; Announcements</h2>
            <ul class="small">
              <li>Your system will be deployed outside of planned windows</li>
              <li>All deployments must be a non-event</li>
            </ul>
          </section>
          <section>
            <span class="chapter">3. Waste</span>
            <h2>Versioning</h2>
            <small>SemVer is for APIs and libraries. <br />A CI/CD App does not have a semantic version.</small>
            <div class="flex flex-distribute flex-gap flex-align-baseline">
              <pre
                style="
                  font-size: 0.4em;
                "><code data-fragment-index="1" class="language-bash" data-trim data-line-numbers="|1|2|3|">
							$ DATE=$(date --utc +%Y%m%d%H%M%S)
							$ GIT_SHA=$(git rev-parse --short HEAD)
							$ BUILD_ID=${GITHUB_RUN_ID}
							$ IMAGE_TAG=${DATE}-${GIT_SHA}-${BUILD_ID}
		
							20230720160020-515b97b-123123
								  </code></pre>
              <ul class="small">
                <li class="fragment" data-fragment-index="1">When was it built </li>
                <li class="fragment" data-fragment-index="2">What was built</li>
                <li class="fragment" data-fragment-index="3">Who built it</li>
              </ul>
            </div>
            <p class="fragment">
              <small>This app runs version <br /><code>{{VERSION}}</code></small>
            </p>
          </section>
        </section>

        <section>
          <section>
            <h1>4. Ownership</h1>
            <img src="/dist/developers.gif" />
          </section>
          <section>
            <span class="chapter">4. Ownership</span>
            <h1>Ownership</h1>
            <ul>
              <li>Who writes the code? <b class="fragment">Devs</b></li>
              <li>Who verifies that it's working as intended? <b class="fragment">Devs</b></li>
              <li>Who decides how to run it? <b class="fragment">Devs</b></li>
              <li>Who verifies that it is running? <b class="fragment">Devs</b></li>
            </ul>
          </section>
          <section>
            <h3 class="h1">What do you need?</h3>
            <ul>
              <li><b>Time</b> to do a good job</li>
              <li><b>Staffing</b> to have all knowledge in the team</li>
              <li><b>Training & Tooling</b> to do the best job you can</li>
            </ul>
          </section>
          <section>
            <h3 class="h1">You need <br /><s>Authority</s> Autonomy</h3>
            <ul>
              <li>over your own <b>commitments</b></li>
              <li>over your team's <b>staffing</b></li>
              <li>to <b>buy tools &amp; trainings</b> you need</li>
            </ul>
          </section>
          <section>
            <h3 class="h1">Platform teams / DevUX</h3>
            <ul class="small">
              <li>Make operations easier for you</li>
              <li>Pick tools and architecture with you</li>
              <li>Provide standard tooling on top of primitives</li>
              <li>Write a lot of YAML so you have to write less YAML</li>
            </ul>
          </section>
        </section>

        <section>
          <section>
            <h1>Archeology</h1>
            <p>Common problems, how to identify them, how to solve them</p>
          </section>
          <section>
            <table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Docker images take 10 minutes to build</b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>No caching, or caching is ineffective</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>Fetch dependencies explicitly before compiling and cache other setup effectively </td>
                      <td>
                        50% reduction of compile time, ~5 minutes per CI run, 1h of delay per day, 200hrs of delay per
                        year
                      </td>
                      <td>days of work</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table>
          </section>
          <section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Maven takes a long time to compile the source code before tests (5min)</b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          >
          <section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Unit Tests take a long time (5min)</b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          >
          <section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>End to End tests take 1h</b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          >
          <section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Creating a production deployment requires a change ticket that is approved</b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          >
          <section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Manual testing after deployment takes a long time and needs special knowledge </b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          ><section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>The application can only be deployed out of business hours </b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          ><section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Pipeline frequently fails for some reason </b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          ><section
            ><table class="small">
              <tr>
                <th>Problem</th>
                <td><b>Services are always deployed together and can't be deployed individually </b></td>
              </tr>
              <tr>
                <th>Educated Guess</th>
                <td>???</td>
              </tr>
              <tr>
                <th>Ideas</th>
                <td>
                  <table class="smaller width-100pct">
                    <tr>
                      <th>Suggested action</th>
                      <th>Potential Impact</th>
                      <th>Cost</th>
                    </tr>
                    <tr>
                      <td>???</td>
                      <td>???</td>
                      <td>???</td>
                    </tr>
                  </table>
                </td>
              </tr>
            </table></section
          >
        </section>
        <section
          ><section>
            <h1>End?</h1>
          </section>
          <section
            ><h3 class="h1">Today</h3
            ><table class="smaller" id="schedule">
              <tr>
                <th>&nbsp;</th>
                <th>Track 1</th>
                <th>Track 2</th>
                <th>Track 3</th>
              </tr>
            </table>
            <script type="application/javascript">
              window.addEventListener("DOMContentLoaded", async () => {
                const scheduleTable = document.querySelector("#schedule");

                const reqScheduleFromKonopas = await fetch("https://scrts-jbe.k8s.with-humans.org/v1/konopas/");
                if (!reqScheduleFromKonopas.ok) return;

                const scheduleData = await reqScheduleFromKonopas.json();

                const events = scheduleData
                  .filter((event) => event.tags.includes("training-day"))
                  .map((event) => ({ ...event, start: new Date(`${event.date} ${event.time}`) }));

                const startTimes = [...new Set(events.map((event) => event.time)).values()].sort();

                for (let time of startTimes) {
                  const tr = document.createElement("tr");
                  const thTime = document.createElement("th");
                  thTime.innerText = time;
                  tr.appendChild(thTime);

                  ["track-1", "track-2", "track-3"].forEach((track) => {
                    const event = events.find((event) => event.time === time && event.tags.includes(track));
                    if (event) {
                      const td = document.createElement("td");
                      td.innerText = `${event.people.map((p) => p.name).join(" & ")}: ${event.title}`;
                      tr.appendChild(td);
                    }
                  });
                  scheduleTable.appendChild(tr);
                }
              });
            </script>
          </section>
          <section>
            <h1>Monday</h1>
            <ul>
              <li>Make your CI a bit faster <br />(delete that test coverage report)</li>
              <li>Skip the review<br />pair with someone</li>
              <li>Do a deployment<br />reflect on what can be done better</li>
            </ul>
          </section>
        </section>
        <section>
          <section>
            <h1>DLC</h1>
            <h2>Cycle Time Tech Hacks</h2>
          </section>
          <section>
            <span class="chapter">2. Cycle Time</span>
            <h2>Dockerfile</h2>
            <div class="flex flex-distribute flex-gap flex-align-baseline">
              <pre
                style="
                  font-size: 0.3em;
                "><code data-fragment-index="1" class="language-dockerfile" data-trim data-line-numbers="|4-5|9|11-14">FROM maven:3.9.3-eclipse-temurin-20 AS builder
WORKDIR /app

COPY pom.xml pom.xml
RUN mvn dependency:go-offline -B -DexcludeReactor=false

COPY src src/
COPY test test/
RUN mvn --offline package

FROM eclipse-temurin:20
WORKDIR /app
COPY --from=builder /app/target/*.jar app.jar
ENTRYPOINT ["java", "-jar", "app.jar"]
					</code></pre>
              <ul class="small">
                <li class="fragment" data-fragment-index="1">Only download dependencies when they've changed </li>
                <li class="fragment" data-fragment-index="2">Run unit tests as part of the docker build </li>
                <li class="fragment" data-fragment-index="3">Multi-stage for small final image size </li>
              </ul>
            </div>
          </section>
          <section>
            <span class="chapter">1. Build Time</span>
            <h2>Docker Build</h2>
            <small
              >Use a next-gen builder with good caching like <br /><em>moby</em>, <em>docker with buildkit</em> or
              <em>kaniko</em>.</small
            >
            <div class="flex flex-distribute flex-gap flex-align-baseline">
              <pre
                style="
                  font-size: 0.3em;
                "><code data-fragment-index="1" class="language-bash" data-trim data-line-numbers="|5|6-7">
							$ buildctl build \
								--frontend dockerfile.v0 \
								--local context=. \
								--local dockerfile=. \
								--output type=image,name=docker.io/app:${TAG},push=true \
								--export-cache type=registry,ref=docker.io/app,mode=max \
								--import-cache type=registry,ref=docker.io/app
						  </code></pre>
              <ul class="small">
                <li class="fragment" data-fragment-index="1">Build and push in a single operation </li>
                <li class="fragment" data-fragment-index="2">Cache every layer in the registry </li>
              </ul>
            </div>
          </section>
        </section>
        <section>
          <section>
            <h1>DLC</h1>
            <h2>Our stack</h2>
          </section>
          <section>
            <h3>Stacks</h3>
            <table class="smaller">
              <tr>
                <th>&nbsp;</th>
                <th>Kubernetes</th>
                <th>SaaS</th>
              </tr>
              <tr>
                <th>Infrastructure as Code</th>
                <td>Pulumi</td>
                <td rowspan="2">CDK/Pulumi/Terraform</td>
              </tr>
              <tr>
                <th>GitOps</th>
                <td>FluxCD</td>
              </tr>
              <tr>
                <th>Pipeline Runner</th>
                <td>Tekton</td>
                <td>GitLab CI/CD</td>
              </tr>
              <tr>
                <th>ServiceMesh</th>
                <td>Linkerd</td>
                <td>-</td>
              </tr>
              <tr>
                <th>Ingress</th>
                <td>Traefik + ACME</td>
                <td>NATS.io</td>
              </tr>
              <tr>
                <th>Monitoring</th>
                <td>Grafana Stack</td>
                <td>Datadog</td>
              </tr>
              <tr>
                <th>Progressive Rollout</th>
                <td>Argo Rollouts</td>
                <td>-</td>
              </tr>
              <tr>
                <th>Feature Flags</th>
                <td>OpenFeature</td>
                <td>Unleash / LaunchDarkly</td>
              </tr>
              <tr>
                <th>AuthN</th>
                <td>Supertoken + Dex + OAuth2-Proxy</td>
                <td>ORY / Auth0</td>
              </tr>
            </table>
          </section>
        </section>

        <section>
          <section>
            <h1>DLC</h1>
            <h2>The sad state of k8s tooling</h2>
          </section>
          <section>
            <h3>Tooling</h3>
            <p class="smaller"
              >Every tool brings it's own CLI instead of a helm chart. Packaged as either a `bin`, a `tar`, a `xz`, a
              `gz`, a `bzip` or any permutation of these
            </p>
            <pre class="smaller"><code class="smaller language-dockerfile">FROM curlimages/curl AS kubectl
# renovate: datasource=docker depName=rancher/k3s versioning=regex:^v(?&lt;major&gt;\d+)\.(?&lt;minor&gt;\d+)\.(?&lt;patch&gt;\d+)-k3s(?&lt;build&gt;\d+)$
FROM curlimages/curl AS argo
# renovate: datasource=github-releases depName=argoproj/argo-workflows versioning=semver
ENV ARGO_WORKFLOWS_VERSION=v3.4.8
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/argoproj/argo-workflows/releases/download/${ARGO_WORKFLOWS_VERSION}/argo-linux-amd64.gz | \
			gunzip > /tmp/argo

FROM curlimages/curl AS argocd
# renovate: datasource=github-releases depName=argoproj/argo-cd versioning=semver
ENV ARGO_CD_VERSION=v2.7.3
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/argoproj/argo-cd/releases/download/${ARGO_CD_VERSION}/argocd-linux-amd64 > /tmp/argocd

FROM curlimages/curl AS linkerd
# renovate: datasource=github-releases depName=linkerd/linkerd2 versioning=regex:stable-(?&lt;major&gt;\d+)\.(?&lt;minor&gt;\d+)\.(?&lt;patch&gt;\d+)
ENV LINKERD_VERSION=stable-2.13.3
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/linkerd/linkerd2/releases/download/${LINKERD_VERSION}/linkerd2-cli-${LINKERD_VERSION}-linux-amd64 > /tmp/linkerd

FROM curlimages/curl AS linkerd-smi
# renovate: datasource=github-releases depName=linkerd/linkerd-smi versioning=semver
ENV LINKERD_SMI_VERSION=v0.2.1
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/linkerd/linkerd-smi/releases/download/${LINKERD_SMI_VERSION}/linkerd-smi-${LINKERD_SMI_VERSION:1}-linux-amd64 > /tmp/linkerd-smi

FROM curlimages/curl AS logcli
# renovate: datasource=github-releases depName=grafana/loki versioning=semver
ENV LOKI_VERSION=v2.8.2
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/grafana/loki/releases/download/${LOKI_VERSION}/logcli-linux-amd64.zip > /tmp/logcli-linux-amd64.zip && \
		unzip -p /tmp/logcli-linux-amd64.zip > /tmp/logcli

FROM curlimages/curl AS argo-rollouts
# renovate: datasource=github-releases depName=argoproj/argo-rollouts versioning=semver
ENV ARGO_ROLLOUTS_VERSION=v1.5.1
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/argoproj/argo-rollouts/releases/download/${ARGO_ROLLOUTS_VERSION}/kubectl-argo-rollouts-linux-amd64 > /tmp/kubectl-argo-rollouts

FROM curlimages/curl AS kyverno
ENV KYVERNO_VERSION=1.7.2
RUN curl --retry 5 --retry-all-errors --fail --silent --show-error --location \
	https://github.com/kyverno/kyverno/releases/download/v1.7.2/kyverno-cli_v1.7.2_linux_x86_64.tar.gz |\
		tar -xzf- -C /tmp/
						</code></pre>
          </section>
          <section>
            <h3>Declarative deployments</h3>
            <p>Are a <span class="h1">red hering</span></p>
            <ul>
              <li
                >Eventually, you will need imperative instructions like helm post-install hooks, terraform null
                providers or pulumi
              </li>
              <li
                >Everything that works on AdmissionWebhooks (policy providers, service meshes) needs to exist before
                other software
              </li>
            </ul>
          </section>
          <section>
            <h3>Service Meshes</h3>
            <p class="smaller"
              >All service meshes work on an opaque layer that reroutes requests inside the cluster using iptables,
              rendering the standard k8s primitives (e.g. service) useless. Most of them require hacks to get edge
              traffic working
            </p>
            <ul>
              <li>
                <b>Linkerd</b> supports wiretapping, SMI Traffic Shifting, but doesn't visualize the cluster well
              </li>
              <li>
                <b>Istio</b> visualizes well, but doesn't support wiretapping and brings its own service abstraction
              </li>
              <li><b>TraefikMesh</b> is abandonware</li>
              <li><b>Kuma/Kong Mesh</b> is Freemiumsource</li>
            </ul>
          </section>
          <section>
            <h3>Ingress</h3>
            <ul>
              <li> <strong>Nginx</strong> might be the best choice for a standard ingress as of now </li>
              <li>
                <strong>Traefik</strong> comes with batteries included, but does not validate or update its CRDs in case
                of an error. OAuth2 is a premium feature
              </li>
              <li> <strong>Istio</strong> brings its own ingress that doesn't to ACME SSL </li>
              <li
                >The new <strong>GatewayAPI</strong> has traffic control mechanics, but only at the ingress, not
                east-west
              </li>
            </ul>
          </section>
          <section>
            <h3>GitOps</h3>
            <ul>
              <li>
                <strong>ArgoCD</strong> has a pretty UI with RBAC and decent log output, but no dependency graph between
                applications, but numbered "sync waves"
              </li>
              <li>
                <strong>FluxCD</strong> has no good UI, little debug output, occasionally hangs but does dependency
                management (but only either between <code>Helm Releases</code> or <code>Kustomizations</code>)
              </li>
              <li> <strong>JenkinsX</strong> does everything including CI/CD and GitOps?! </li>
            </ul>
          </section>
          <section>
            <h3>Progressive Rollout Operator</h3>
            <p class="smaller"
              >The only reason to have a PRO is to shift traffic weights during rollout. The attention is wrongly
              directed towards ingresses though.
            </p>
            <ul>
              <li>
                <strong>Argo Rollouts</strong> has traffic shifting via SMI or for selected ingress/service mesh
                providers, but is badly documented
              </li>
              <li>
                <strong>Flagger</strong> doesn't support defining your own rollout sequence and integrates exclusively
                over webhooks
              </li>
            </ul>
          </section>
          <section>
            <h3>CI Pipelines</h3>
            <ul>
              <li> <strong>Argo Workflows</strong> is slow, badly documented and isn't optimized for CI pipelines </li>
              <li>
                <strong>Tekton</strong> is faster, caters more to CI pipelines, but samples and blueprints are outdated
                and underdocumented
              </li>
              <li> <strong>JenkinsX</strong> does everything including CI/CD and GitOps?! </li>
            </ul>
          </section>
          <section>
            <h3>AuthN Provider</h3>
            <ul>
              <li> <strong>ORY</strong> Kratos and Hydra don't officially work together </li>
              <li> <strong>Keycloak</strong> is dated, not cloud-native and too complex </li>
              <li> <strong>Supertokens</strong> barely does what you want, but with little documentation </li>
            </ul>
          </section>
        </section>
      </div>
      <div class="toggle">
        <form name="extreme">
          <input type="radio" name="on" id="extreme_on" value="true" /> <label for="extreme_on">Extreme</label>
          <input type="radio" name="on" id="extreme_off" value="false" checked /> <label for="extreme_off">Meh</label>
        </form>
      </div>
    </div>

    <script type="application/javascript">
      window.addEventListener("DOMContentLoaded", () => {
        const form = document.forms.extreme;

        const toggleExtreme = () => {
          const extreme = form.elements.on;
          for (let e of [...document.querySelectorAll("[data-extreme][data-meh]")]) {
            if (extreme.value === "true") {
              e.innerText = e.dataset.extreme;
            } else {
              e.innerText = e.dataset.meh;
            }
          }
        };

        form.addEventListener("change", toggleExtreme);
        toggleExtreme();
      });
    </script>
    <script src="dist/reveal.js"></script>
    <script src="plugin/notes/notes.js"></script>
    <script src="plugin/markdown/markdown.js"></script>
    <script src="plugin/highlight/highlight.js"></script>
    <script>
      // More info about initialization & config:
      // - https://revealjs.com/initialization/
      // - https://revealjs.com/config/
      Reveal.initialize({
        hash: true,
        navigationMode: "linear",
        transition: "fade",
        // Learn about plugins: https://revealjs.com/plugins/
        plugins: [RevealMarkdown, RevealHighlight, RevealNotes],
      });

      document.addEventListener("DOMContentLoaded", () => {
        if (document.querySelector("todo")) {
          document.body.classList.add("has-todos");
        }
      });
    </script>
  </body>
</html>
